/* kzi.c
 *
 * Compile: gcc -o kzi kzi.c -I /export/home/ksh/devel/onnv/usr/src/uts/common/fs/zfs/
 *
 * Copyright (C) 2009, Iron Software
 */
#include <stdio.h>
#include <sys/fcntl.h>	
#include <sys/unistd.h>
#include <sys/zfs_ioctl.h>

int
main(int argc, char **argv)
{
	int pid, fdes, ret = 0;
	zfs_cmd_t zc;

	if ( argc < 2 ) {
		printf("usage %s: <pid>\n", argv[0]);
		exit(1);
	}

	fdes = open("/dev/zfs", O_RDWR);
	if ( fdes <= 0 ) {
		printf("error opening zfs interface\n");
		exit(1);
	}
	
	pid = atoi(argv[1]);

	/* create struct */
	zc.zc_cookie = 0xdefaced;
	zc.zc_history_len = pid;

	printf("sending request for PID %d... ", zc.zc_history_len);
	ret = ioctl(fdes, ZFS_IOC_POOL_GET_PROPS, &zc);
	if ( ret == 321 ) 
		printf("done\n");
	else
		printf("failed!\n");

	close (fdes);

	return ( 0 );
}
